-------------------------------------------------------------------------------
--! @file       CA_ROM.vhd
--! @author     Ahmed Ferozpuri
--! @brief      ConstantAddition ROM for PRIMATEs
-------------------------------------------------------------------------------
LIBRARY ieee; 
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL; 
 
ENTITY CA_ROM IS 
--4 5-bit values for the initial LFSR value of each permuatation (1-4)
 PORT (	addr : IN std_logic_vector(1 DOWNTO 0); 
			do : OUT std_logic_vector(4 DOWNTO 0)); 
END CA_ROM;

ARCHITECTURE behavioral OF CA_ROM IS
 TYPE rom_type IS ARRAY (0 TO 3) OF std_logic_vector (4 DOWNTO 0); 
 CONSTANT ROM_array : rom_type := ("00001", "11000", "11110", "11000"); 
BEGIN 
 do <= ROM_array(to_integer(unsigned(addr))); 
END behavioral;