-------------------------------------------------------------------------------
--! @file       GF5M18.vhd
--! @author     Ahmed Ferozpuri
--! @brief      GF Multier 5bit x 18
-------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY GF5M18 IS
	PORT(	d_i : IN  std_logic_vector(4 DOWNTO 0);
			d_o : OUT  std_logic_vector(4 DOWNTO 0)
		);
END GF5M18;

ARCHITECTURE behavioral OF GF5M18 IS

SIGNAL M21, M22, M23, M24: std_logic_vector(4 DOWNTO 0);

BEGIN

	M21O: ENTITY work.GF5M2(behavioral) PORT MAP(d_i => d_i, d_o => M21);
	M22O: ENTITY work.GF5M2(behavioral) PORT MAP(d_i => M21, d_o => M22);
	M23O: ENTITY work.GF5M2(behavioral) PORT MAP(d_i => M22, d_o => M23);
	M24O: ENTITY work.GF5M2(behavioral) PORT MAP(d_i => M23, d_o => M24);

	d_o <= M21 xor M24;
END behavioral;