-------------------------------------------------------------------------------
--! @file       PISON_M.vhd
--! @author     Ahmed Ferozpuri
--! @brief      Generic NxM PISO
-------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY PISON_M IS
GENERIC (N : INTEGER := 80;--PARALLEL SIZE
			M : INTEGER := 40);--SERIAL SIZE
	PORT (	D : IN STD_LOGIC_VECTOR(N-1 DOWNTO 0);
				clk, en, ld : IN STD_LOGIC;
				Q : OUT STD_LOGIC_VECTOR(M-1 DOWNTO 0));
END PISON_M;
 
ARCHITECTURE behavioral OF PISON_M IS

SIGNAL QL : STD_LOGIC_VECTOR(N-1 DOWNTO 0);

BEGIN

	--Q <= QL(M-1 DOWNTO 0);
	Q <= QL(N-1 DOWNTO N-M);
	PROCESS (clk)
	BEGIN
		IF rising_edge(clk) THEN
			IF ld='1' THEN
				QL <= D;
			ELSIF en='1' THEN
--				QL(N-1 DOWNTO N-M) <= (OTHERS => '0'); --MSBLOCK SHIFTED WITH 0
				QL(M-1 DOWNTO 0) <= (OTHERS => '0'); --MSBLOCK SHIFTED WITH 0
--				QL(N-M-1 DOWNTO 0) <= QL(N-1 DOWNTO M);
				QL(N-1 DOWNTO M) <= QL(N-M-1 DOWNTO 0);
			END IF;
		END IF;
	END PROCESS;
END behavioral;