-------------------------------------------------------------------------------
--! @file       SBOXINV.vhd
--! @author     Ahmed Ferozpuri
--! @brief      Inverse SBOX for PRIMATEs
-------------------------------------------------------------------------------
LIBRARY ieee; 
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL; 
 
ENTITY SBOXINV IS 
--4 5-bit values for the initial LFSR value of each permuatation (1-4)
 PORT (	addr : IN std_logic_vector(4 DOWNTO 0); 
			do : OUT std_logic_vector(4 DOWNTO 0)); 
END SBOXINV;

ARCHITECTURE behavioral OF SBOXINV IS
 TYPE rom_type IS ARRAY (0 TO 31) OF std_logic_vector (4 DOWNTO 0); 
 CONSTANT ROM_array : rom_type := ("00001", "00000", "01110", "10011",
											  "01010", "01001", "10010", "10101",
											  "10001", "11001", "11011", "11110",
											  "11101", "10100", "01100", "10000",
											  "10111", "00100", "01101", "11111",
											  "01000", "00110", "11100", "01011",
											  "10110", "00010", "00011", "00111",
											  "01111", "00101", "11000", "11010");
--1, 0, 14, 19, 10, 9, 18, 21,
--17, 25, 27, 30, 29, 20, 12, 16,
--23, 4, 13, 31, 8, 6, 28, 11, 
--22, 2, 3, 7, 15, 5, 24, 26
BEGIN 
 do <= ROM_array(to_integer(unsigned(addr))); 
END behavioral;

